import {schema} from './src';
import R from 'ramda';

function createSchemaFromConfig(type, mapper, config) {
  return schema.type(type, R.pipe(
    R.groupBy(R.prop('key')),
    R.map(R.pipe(
      R.groupBy(R.prop('rule')),
      R.map(R.pipe(
        R.head,
        (row) => schema.constraint(
          mapper(row),
          row.message
        ),
      )),
    )),
  )(config));
}

function mapper(row) {
  switch (row.rule) {
  case 'notEmpty':
    return schema.validators.isNotEmpty;
  default:
    throw new Error(`Unkown validation rule "${row.rule}"`);
  }
}

const s = createSchemaFromConfig('user', mapper, [
  {key: 'username', rule: 'notEmpty', message: 'a'}
])

s.check({username: ''}).then(q => console.log(q));
